﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Infragistics.Win.FormattedLinkLabel;

namespace Test_FormattedText
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ubutTest_Click(object sender, EventArgs e)
        {
            if (!this.uFTEditor1.IsInEditMode)
                return;

            // Try to select the word
            this.uFTEditor1.EventManager.SetEnabled(EventIds.EditStateChanged, false);  // to avoid EH executing
            this.uFTEditor1.BeginUpdate();  // to avoid screen flashing
            
            // Trap current position to reset after style change
            int currSelectedIdx = this.uFTEditor1.EditInfo.SelectionStart;
            // Trap the word start index
            this.uFTEditor1.EditInfo.PerformAction(FormattedLinkEditorAction.WordLeft);
            int selStart = this.uFTEditor1.EditInfo.SelectionStart;
            
            // WordRight seems to miss multiple spaces (&edsp;) and selects to end of line
            // Walk right till find space or return; find selection length
            this.uFTEditor1.EditInfo.SelectionStart = currSelectedIdx;
            this.uFTEditor1.EditInfo.SelectionLength = 1;
            char currChar = this.uFTEditor1.EditInfo.GetSelectedValueAsString(true)[0];
            while (currChar != ' ' && currChar != '\r')
            {
                this.uFTEditor1.EditInfo.SelectionStart++;
                currChar = this.uFTEditor1.EditInfo.GetSelectedValueAsString(true)[0];  // true for no tags, no images, etc.
            }
            int length = this.uFTEditor1.EditInfo.SelectionStart + 1 - selStart;
            
            // Adjust SelectionStart/Length to the word + one space
            this.uFTEditor1.EditInfo.SelectionStart = selStart;
            // The line above picks some random start and length; then after SelectionStart can no longer be set
            if (this.uFTEditor1.EditInfo.SelectionStart != selStart)
            {
                MessageBox.Show("SelectionStart cannot be set.");
                return;
            }

            // Select the word
            this.uFTEditor1.EditInfo.SelectionLength = length;

            this.uFTEditor1.EditInfo.ApplyStyle("color" + ":" + Color.Red.Name + ";", false);

            this.uFTEditor1.EventManager.SetEnabled(EventIds.EditStateChanged, true);
            this.uFTEditor1.EndUpdate();

        }

        private void ubutClearStyle_Click(object sender, EventArgs e)
        {
            if (!this.uFTEditor1.IsInEditMode)
                return;

            this.uFTEditor1.EditInfo.ClearStyleAttributes(new string[] { "color" } );

        }

    }
}
